Linux tsuru-no-tsurugi 5.15.0-186-generic #196-Ubuntu SMP Sat Jun 20 16:09:34 UTC 2026 x86_64
Apache/2.4.52 (Ubuntu)
Server IP : 192.168.0.18 & Your IP : 216.73.217.105
Domains :
Cant Read [ /etc/named.conf ]
User : www-data
Terminal
Auto Root
Create File
Create Folder
Localroot Suggester
Backdoor Destroyer
Readme
/
snap /
core20 /
2866 /
usr /
sbin /
Delete
Unzip
Name
Size
Permission
Date
Action
aa-remove-unknown
3
KB
-rwxr-xr-x
2024-03-07 03:40
aa-status
8.63
KB
-rwxr-xr-x
2024-03-07 03:40
aa-teardown
139
B
-rwxr-xr-x
2019-06-18 08:55
add-shell
860
B
-rwxr-xr-x
2019-12-07 11:13
addgroup
36.9
KB
-rwxr-xr-x
2020-04-16 23:12
adduser
36.9
KB
-rwxr-xr-x
2020-04-16 23:12
agetty
67.38
KB
-rwxr-xr-x
2026-03-07 01:20
apparmor_parser
1.46
MB
-rwxr-xr-x
2024-03-07 03:40
apparmor_status
8.63
KB
-rwxr-xr-x
2024-03-07 03:40
arpd
78.27
KB
-rwxr-xr-x
2020-02-14 02:21
arptables
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
arptables-nft
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
arptables-nft-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
arptables-nft-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
arptables-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
arptables-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
badblocks
34.32
KB
-rwxr-xr-x
2023-10-09 10:56
blkdeactivate
14.49
KB
-rwxr-xr-x
2020-02-14 06:21
blkdiscard
34.23
KB
-rwxr-xr-x
2026-03-07 01:20
blkid
118.26
KB
-rwxr-xr-x
2026-03-07 01:20
blkzone
70.23
KB
-rwxr-xr-x
2026-03-07 01:20
blockdev
66.23
KB
-rwxr-xr-x
2026-03-07 01:20
bridge
102.3
KB
-rwxr-xr-x
2020-02-14 02:21
capsh
30.3
KB
-rwxr-xr-x
2025-02-21 01:01
cfdisk
102.59
KB
-rwxr-xr-x
2026-03-07 01:20
chcpu
46.23
KB
-rwxr-xr-x
2026-03-07 01:20
chgpasswd
66.2
KB
-rwxr-xr-x
2024-02-06 21:49
chmem
62.23
KB
-rwxr-xr-x
2026-03-07 01:20
chpasswd
58.2
KB
-rwxr-xr-x
2024-02-06 21:49
chroot
42.34
KB
-rwxr-xr-x
2019-09-05 19:38
cpgr
60.34
KB
-rwxr-xr-x
2024-02-06 21:49
cppw
60.34
KB
-rwxr-xr-x
2024-02-06 21:49
cryptdisks_start
1.51
KB
-rwxr-xr-x
2020-02-04 22:11
cryptdisks_stop
844
B
-rwxr-xr-x
2020-02-04 22:11
cryptsetup
135.54
KB
-rwxr-xr-x
2025-01-30 03:37
cryptsetup-reencrypt
105.32
KB
-rwxr-xr-x
2025-01-30 03:37
ctrlaltdel
38.23
KB
-rwxr-xr-x
2026-03-07 01:20
debugfs
225.8
KB
-rwxr-xr-x
2023-10-09 10:56
delgroup
16.11
KB
-rwxr-xr-x
2020-04-16 23:12
deluser
16.11
KB
-rwxr-xr-x
2020-04-16 23:12
depmod
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
devlink
150.47
KB
-rwxr-xr-x
2020-02-14 02:21
dhclient
508.98
KB
-rwxr-xr-x
2023-02-01 07:10
dhclient-script
15.92
KB
-rwxr-xr-x
2023-02-01 07:10
dmsetup
171.02
KB
-rwxr-xr-x
2020-02-14 06:21
dmstats
171.02
KB
-rwxr-xr-x
2020-02-14 06:21
dosfsck
58.08
KB
-rwxr-xr-x
2018-05-13 07:59
dosfslabel
54.08
KB
-rwxr-xr-x
2018-05-13 07:59
dumpe2fs
30.38
KB
-rwxr-xr-x
2023-10-09 10:56
e2freefrag
18.38
KB
-rwxr-xr-x
2023-10-09 10:56
e2fsck
327.21
KB
-rwxr-xr-x
2023-10-09 10:56
e2image
42.38
KB
-rwxr-xr-x
2023-10-09 10:56
e2label
106.55
KB
-rwxr-xr-x
2023-10-09 10:56
e2mmpstatus
30.38
KB
-rwxr-xr-x
2023-10-09 10:56
e2scrub
7.13
KB
-rwxr-xr-x
2023-10-09 10:56
e2scrub_all
5.27
KB
-rwxr-xr-x
2023-10-09 10:56
e2undo
22.38
KB
-rwxr-xr-x
2023-10-09 10:56
e4crypt
30.38
KB
-rwxr-xr-x
2023-10-09 10:56
e4defrag
34.3
KB
-rwxr-xr-x
2023-10-09 10:56
ebtables
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ebtables-nft
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ebtables-nft-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ebtables-nft-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ebtables-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ebtables-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
faillock
14.15
KB
-rwxr-xr-x
2024-01-10 22:55
fatlabel
54.08
KB
-rwxr-xr-x
2018-05-13 07:59
fdformat
34.23
KB
-rwxr-xr-x
2026-03-07 01:20
fdisk
150.27
KB
-rwxr-xr-x
2026-03-07 01:20
filefrag
18.33
KB
-rwxr-xr-x
2023-10-09 10:56
findfs
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
fsck
54.27
KB
-rwxr-xr-x
2026-03-07 01:20
fsck.cramfs
38.26
KB
-rwxr-xr-x
2026-03-07 01:20
fsck.ext2
327.21
KB
-rwxr-xr-x
2023-10-09 10:56
fsck.ext3
327.21
KB
-rwxr-xr-x
2023-10-09 10:56
fsck.ext4
327.21
KB
-rwxr-xr-x
2023-10-09 10:56
fsck.fat
58.08
KB
-rwxr-xr-x
2018-05-13 07:59
fsck.minix
122.25
KB
-rwxr-xr-x
2026-03-07 01:20
fsck.msdos
58.08
KB
-rwxr-xr-x
2018-05-13 07:59
fsck.vfat
58.08
KB
-rwxr-xr-x
2018-05-13 07:59
fsfreeze
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
fstab-decode
14.3
KB
-rwxr-xr-x
2020-02-14 03:38
fstrim
70.23
KB
-rwxr-xr-x
2026-03-07 01:20
genl
82.29
KB
-rwxr-xr-x
2020-02-14 02:21
getcap
14.3
KB
-rwxr-xr-x
2025-02-21 01:01
getpcaps
14.3
KB
-rwxr-xr-x
2025-02-21 01:01
getty
67.38
KB
-rwxr-xr-x
2026-03-07 01:20
groupadd
90.95
KB
-rwxr-xr-x
2024-02-06 21:49
groupdel
86.77
KB
-rwxr-xr-x
2024-02-06 21:49
groupmems
62.24
KB
-rwxr-xr-x
2024-02-06 21:49
groupmod
94.86
KB
-rwxr-xr-x
2024-02-06 21:49
grpck
62.18
KB
-rwxr-xr-x
2024-02-06 21:49
grpconv
58.05
KB
-rwxr-xr-x
2024-02-06 21:49
grpunconv
58.05
KB
-rwxr-xr-x
2024-02-06 21:49
halt
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
hwclock
102.35
KB
-rwxr-xr-x
2026-03-07 01:20
iconvconfig
30.4
KB
-rwxr-xr-x
2026-01-30 17:05
init
1.76
MB
-rwxr-xr-x
2026-06-06 00:40
insmod
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
installkernel
2.58
KB
-rwxr-xr-x
2019-12-07 11:13
integritysetup
60.23
KB
-rwxr-xr-x
2025-01-30 03:37
invoke-rc.d
16.64
KB
-rwxr-xr-x
2019-06-22 03:56
ip
702.05
KB
-rwxr-xr-x
2025-10-03 22:53
ip6tables
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-apply
6.89
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-legacy
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-legacy-restore
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-legacy-save
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-nft
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-nft-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-nft-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-restore
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-restore-translate
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-save
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
ip6tables-translate
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
iptables
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-apply
6.89
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-legacy
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-legacy-restore
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-legacy-save
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-nft
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-nft-restore
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-nft-save
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-restore
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-restore-translate
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-save
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
iptables-translate
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
isosize
30.23
KB
-rwxr-xr-x
2026-03-07 01:20
killall5
26.38
KB
-rwxr-xr-x
2020-02-14 03:38
ldattach
34.23
KB
-rwxr-xr-x
2026-03-07 01:20
ldconfig
387
B
-rwxr-xr-x
2026-01-30 17:05
ldconfig.real
1
MB
-rwxr-xr-x
2026-01-30 17:05
logsave
14.16
KB
-rwxr-xr-x
2023-10-09 10:56
losetup
110.34
KB
-rwxr-xr-x
2026-03-07 01:20
lsmod
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
luksformat
3.32
KB
-rwxr-xr-x
2020-02-04 22:11
mkdosfs
34.5
KB
-rwxr-xr-x
2018-05-13 07:59
mke2fs
134.62
KB
-rwxr-xr-x
2023-10-09 10:56
mkfs
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
mkfs.bfs
34.23
KB
-rwxr-xr-x
2026-03-07 01:20
mkfs.cramfs
42.16
KB
-rwxr-xr-x
2026-03-07 01:20
mkfs.ext2
134.62
KB
-rwxr-xr-x
2023-10-09 10:56
mkfs.ext3
134.62
KB
-rwxr-xr-x
2023-10-09 10:56
mkfs.ext4
134.62
KB
-rwxr-xr-x
2023-10-09 10:56
mkfs.fat
34.5
KB
-rwxr-xr-x
2018-05-13 07:59
mkfs.minix
106.23
KB
-rwxr-xr-x
2026-03-07 01:20
mkfs.msdos
34.5
KB
-rwxr-xr-x
2018-05-13 07:59
mkfs.vfat
34.5
KB
-rwxr-xr-x
2018-05-13 07:59
mkhomedir_helper
22.17
KB
-rwxr-xr-x
2024-01-10 22:55
mklost+found
14.3
KB
-rwxr-xr-x
2023-10-09 10:56
mkswap
106.23
KB
-rwxr-xr-x
2026-03-07 01:20
modinfo
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
modprobe
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
netplan
798
B
-rwxr-xr-x
2024-06-29 01:59
newusers
98.8
KB
-rwxr-xr-x
2024-02-06 21:49
nfnl_osf
18.3
KB
-rwxr-xr-x
2023-05-10 03:39
nologin
14.3
KB
-rwxr-xr-x
2024-02-06 21:49
pam-auth-update
19.86
KB
-rwxr-xr-x
2021-09-17 15:05
pam_extrausers_chkpwd
42.16
KB
-rwxr-sr-x
2024-01-10 22:55
pam_extrausers_update
42.16
KB
-rwxr-xr-x
2024-01-10 22:55
pam_getenv
2.82
KB
-rwxr-xr-x
2020-08-12 09:15
pam_tally
14.16
KB
-rwxr-xr-x
2024-01-10 22:55
pam_tally2
18.16
KB
-rwxr-xr-x
2024-01-10 22:55
pam_timestamp_check
14.15
KB
-rwxr-xr-x
2024-01-10 22:55
pivot_root
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
poweroff
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
pwck
58.17
KB
-rwxr-xr-x
2024-02-06 21:49
pwconv
54.05
KB
-rwxr-xr-x
2024-02-06 21:49
pwunconv
54.05
KB
-rwxr-xr-x
2024-02-06 21:49
raw
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
readprofile
22.26
KB
-rwxr-xr-x
2026-03-07 01:20
reboot
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
remove-shell
904
B
-rwxr-xr-x
2019-12-07 11:13
resize2fs
66.38
KB
-rwxr-xr-x
2023-10-09 10:56
rfkill
50.23
KB
-rwxr-xr-x
2026-03-07 01:20
rmmod
166.36
KB
-rwxr-xr-x
2026-04-30 21:32
rmt
58.55
KB
-rwxr-xr-x
2023-12-05 14:16
rmt-tar
58.55
KB
-rwxr-xr-x
2023-12-05 14:16
rtacct
48.29
KB
-rwxr-xr-x
2020-02-14 02:21
rtcwake
46.23
KB
-rwxr-xr-x
2026-03-07 01:20
rtmon
78.24
KB
-rwxr-xr-x
2020-02-14 02:21
runlevel
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
runuser
66.23
KB
-rwxr-xr-x
2026-03-07 01:20
service
9.04
KB
-rwxr-xr-x
2019-06-22 03:56
setcap
14.3
KB
-rwxr-xr-x
2025-02-21 01:01
sfdisk
138.23
KB
-rwxr-xr-x
2026-03-07 01:20
shadowconfig
885
B
-rwxr-xr-x
2021-07-15 07:08
shutdown
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
sshd
863.79
KB
-rwxr-xr-x
2026-03-06 04:37
start-stop-daemon
47.32
KB
-rwxr-xr-x
2022-05-25 20:14
sulogin
50.23
KB
-rwxr-xr-x
2026-03-07 01:20
swaplabel
18.23
KB
-rwxr-xr-x
2026-03-07 01:20
swapoff
22.23
KB
-rwxr-xr-x
2026-03-07 01:20
swapon
50.23
KB
-rwxr-xr-x
2026-03-07 01:20
switch_root
14.23
KB
-rwxr-xr-x
2026-03-07 01:20
sysctl
30.23
KB
-rwxr-xr-x
2023-10-31 20:35
tarcat
936
B
-rwxr-xr-x
2023-12-05 14:16
tc
529.45
KB
-rwxr-xr-x
2020-02-14 02:21
telinit
1.06
MB
-rwxr-xr-x
2026-06-06 00:40
tipc
126.23
KB
-rwxr-xr-x
2020-02-14 02:21
tune2fs
106.55
KB
-rwxr-xr-x
2023-10-09 10:56
tzconfig
106
B
-rwxr-xr-x
2025-04-22 19:15
unix_chkpwd
42.15
KB
-rwxr-sr-x
2024-01-10 22:55
unix_update
42.15
KB
-rwxr-xr-x
2024-01-10 22:55
update-ca-certificates
5.29
KB
-rwxr-xr-x
2024-09-25 02:46
update-mime
9.18
KB
-rwxr-xr-x
2019-10-19 08:05
update-passwd
34.56
KB
-rwxr-xr-x
2019-12-17 08:51
update-rc.d
16.76
KB
-rwxr-xr-x
2019-06-22 03:56
useradd
143.71
KB
-rwxr-xr-x
2024-02-06 21:49
userdel
98.89
KB
-rwxr-xr-x
2024-02-06 21:49
usermod
139.49
KB
-rwxr-xr-x
2024-02-06 21:49
veritysetup
51.82
KB
-rwxr-xr-x
2025-01-30 03:37
vigr
68.55
KB
-rwxr-xr-x
2024-02-06 21:49
vipw
68.55
KB
-rwxr-xr-x
2024-02-06 21:49
visudo
218.2
KB
-rwxr-xr-x
2025-06-26 05:10
wipefs
46.23
KB
-rwxr-xr-x
2026-03-07 01:20
wpa_action
1.69
KB
-rwxr-xr-x
2019-08-14 08:12
wpa_cli
152.22
KB
-rwxr-xr-x
2025-02-25 05:14
wpa_supplicant
2.77
MB
-rwxr-xr-x
2025-02-25 05:14
xtables-legacy-multi
96.97
KB
-rwxr-xr-x
2023-05-10 03:39
xtables-monitor
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
xtables-nft-multi
215.32
KB
-rwxr-xr-x
2023-05-10 03:39
zic
62.29
KB
-rwxr-xr-x
2026-01-30 17:05
zramctl
114.34
KB
-rwxr-xr-x
2026-03-07 01:20
Save
Rename
#!/bin/bash # Copyright (C) 2018 Oracle. All Rights Reserved. # # Author: Darrick J. Wong <darrick.wong@oracle.com> # # This program is free software; you can redistribute it and/or # modify it under the terms of the GNU General Public License # as published by the Free Software Foundation; either version 2 # of the License, or (at your option) any later version. # # This program is distributed in the hope that it would be useful, # but WITHOUT ANY WARRANTY; without even the implied warranty of # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the # GNU General Public License for more details. # # You should have received a copy of the GNU General Public License # along with this program; if not, write the Free Software Foundation, # Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA. # Automatically check an LVM-managed filesystem online. # We use lvm snapshots to do this, which means that we can only # check filesystems in VGs that have at least 256MB (or so) of # free space. PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin if (( $EUID != 0 )); then echo "e2scrub must be run as root" exit 1 fi snap_size_mb=256 fstrim=0 reap=0 e2fsck_opts="" conffile="/etc/e2scrub.conf" test -f "${conffile}" && . "${conffile}" print_help() { echo "Usage: $0 [OPTIONS] mountpoint | device" echo echo "mountpoint must be on an LVM-managed block device" echo "-n: Show what commands e2scrub would execute." echo "-r: Remove e2scrub snapshot and exit, do not check anything." echo "-t: Run fstrim if successful." echo "-V: Print version information and exit." } print_version() { echo "e2scrub 1.45.5 (07-Jan-2020)" } exitcode() { ret="$1" # If we're being run as a service, the return code must fit the LSB # init script action error guidelines, which is to say that we # compress all errors to 1 ("generic or unspecified error", LSB 5.0 # section 22.2) and hope the admin will scan the log for what # actually happened. # We have to sleep 2 seconds here because journald uses the pid to # connect our log messages to the systemd service. This is critical # for capturing all the log messages if the scrub fails, because the # fail service uses the service name to gather log messages for the # error report. if [ -n "${SERVICE_MODE}" -a "${ret}" -ne 0 ]; then test "${ret}" -ne 0 && ret=1 sleep 2 fi exit "${ret}" } while getopts "nrtV" opt; do case "${opt}" in "n") DBG="echo Would execute: " ;; "r") reap=1;; "t") fstrim=1;; "V") print_version; exitcode 0;; *) print_help; exitcode 2;; esac done shift "$((OPTIND - 1))" arg="$1" if [ -z "${arg}" ]; then print_help exitcode 1 fi if ! type lsblk >& /dev/null ; then echo "e2scrub: can't find lsblk --- is util-linux installed?" exitcode 1 fi if ! type lvcreate >& /dev/null ; then echo "e2scrub: can't find lvcreate --- is lvm2 installed?" exitcode 1 fi # close file descriptor 3 (from cron) since it causes lvm to kvetch exec 3<&- # Find the device for a given mountpoint dev_from_mount() { local mountpt="$(realpath "$1")" lsblk -o NAME,FSTYPE,MOUNTPOINT -p -P -n 2> /dev/null | while read vars; do eval "${vars}" if [ "${mountpt}" != "${MOUNTPOINT}" ]; then continue fi case "${FSTYPE}" in ext[234]) echo "${NAME}" return 0 ;; esac done return 1 } # Check a device argument dev_from_arg() { local dev="$1" local fstype="$(lsblk -o FSTYPE -n "${dev}" 2> /dev/null)" case "${fstype}" in ext[234]) echo "${dev}" return 0 ;; esac return 1 } mnt_from_dev() { local dev="$1" if [ -n "${dev}" ]; then lsblk -o MOUNTPOINT -n "${dev}" fi } # Construct block device path and mountpoint from argument if [ -b "${arg}" ]; then dev="$(dev_from_arg "${arg}")" mnt="$(mnt_from_dev "${dev}")" else dev="$(dev_from_mount "${arg}")" mnt="${arg}" fi if [ ! -e "${dev}" ]; then echo "${arg}: Not an ext[234] filesystem." print_help exitcode 16 fi # Make sure this is an LVM device we can snapshot lvm_vars="$(lvs --nameprefixes -o name,vgname,lv_role --noheadings "${dev}" 2> /dev/null)" eval "${lvm_vars}" if [ -z "${LVM2_VG_NAME}" ] || [ -z "${LVM2_LV_NAME}" ] || echo "${LVM2_LV_ROLE}" | grep -q "snapshot"; then echo "${arg}: Not connnected to an LVM logical volume." print_help exitcode 16 fi start_time="$(date +'%Y%m%d%H%M%S')" snap="${LVM2_LV_NAME}.e2scrub" snap_dev="/dev/${LVM2_VG_NAME}/${snap}" teardown() { # Remove and wait for removal to succeed. ${DBG} lvremove -f "${LVM2_VG_NAME}/${snap}" while [ -e "${snap_dev}" ] && [ "$?" -eq "5" ]; do sleep 0.5 ${DBG} lvremove -f "${LVM2_VG_NAME}/${snap}" done } check() { # First we recover the journal, then we see if e2fsck tries any # non-optimization repairs. If either of these two returns a # non-zero status (errors fixed or remaining) then this fs is bad. E2FSCK_FIXES_ONLY=1 export E2FSCK_FIXES_ONLY ${DBG} "/sbin/e2fsck" -E journal_only -p ${e2fsck_opts} "${snap_dev}" || return $? ${DBG} "/sbin/e2fsck" -f -y ${e2fsck_opts} "${snap_dev}" } mark_clean() { ${DBG} "/sbin/tune2fs" -C 0 -T "${start_time}" "${dev}" } mark_corrupt() { ${DBG} "/sbin/tune2fs" -E force_fsck "${dev}" } setup() { # Try to remove snapshot for 30s, bail out if we can't remove it. lvremove_deadline="$(( $(date "+%s") + 30))" ${DBG} lvremove -f "${LVM2_VG_NAME}/${snap}" 2>/dev/null while [ -e "${snap_dev}" ] && [ "$?" -eq "5" ] && [ "$(date "+%s")" -lt "${lvremove_deadline}" ]; do sleep 0.5 ${DBG} lvremove -f "${LVM2_VG_NAME}/${snap}" done if [ -e "${snap_dev}" ]; then echo "${arg}: e2scrub snapshot is in use, cannot check!" return 1 fi # Create the snapshot, wait for device to appear. ${DBG} lvcreate -s -L "${snap_size_mb}m" -n "${snap}" "${LVM2_VG_NAME}/${LVM2_LV_NAME}" if [ $? -ne 0 ]; then echo "${arg}: e2scrub snapshot FAILED, will not check!" return 1 fi ${DBG} udevadm settle 2> /dev/null return 0 } if [ "${reap}" -gt 0 ]; then if [ -e "${snap_dev}" ]; then teardown 2> /dev/null fi exit 0 fi if ! setup; then exitcode 8 fi trap "teardown; exit 1" EXIT INT QUIT TERM # Check and react check case "$?" in "0") # Clean check! echo "${arg}: Scrub succeeded." mark_clean teardown trap '' EXIT # Trim the free space, which requires the snapshot be deleted. if [ "${fstrim}" -eq 1 ] && [ -d "${mnt}" ] && type fstrim > /dev/null 2>&1; then echo "${arg}: Trimming free space." fstrim -v "${mnt}" fi ret=0 ;; "8") # Operational error, what now? echo "${arg}: e2fsck operational error." teardown trap '' EXIT ret=8 ;; *) # fsck failed. Check if the snapshot is invalid; if so, make a # note of that at the end of the log. This isn't necessarily a # failure because the mounted fs could have overflowed the # snapshot with regular disk writes /or/ our repair process # could have done it by repairing too much. # # If it's really corrupt we ought to fsck at next boot. is_invalid="$(lvs -o lv_snapshot_invalid --noheadings "${snap_dev}" | awk '{print $1}')" if [ -n "${is_invalid}" ]; then echo "${arg}: Scrub FAILED due to invalid snapshot." ret=8 else echo "${arg}: Scrub FAILED due to corruption! Unmount and run e2fsck -y." mark_corrupt ret=6 fi teardown trap '' EXIT ;; esac exitcode "${ret}"